#include "conv2d.h"
#include <float.h>
#include <math.h>
#include "mfcc.h"
#include "data.h"
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include "memory_management.h"

float *conv1_p = 0; //[4][30][30]  
float *pool1_p = 0; //[4][15][15]
float *conv2_temp_p=0;//[4][4][13][13]
float *conv2_p = 0;//[4][13][13]
float *pool2_p = 0;//[4][6][6]
float *conv3_temp_p = 0;//[4][4][4][4]
float *conv3_p=0;//[4][4][4]
float *flattenD_p = 0;//[64]
float *denseout1_p = 0;//[8]; 
float *denseout2_p = 0;//[3]; 


 
 
// 弤
typedef float (*ActivationFunction)(float);

// ReLUʵ
float relu(float x) {
    return x > 0 ? x : 0;
}

// ߼sigmoid
float sigmoid(float x) {
    return 1.0 / (1.0 + exp(-x));
}

// ӦüÿԪصĺ
void apply_activation_function(float *input, int rows, int cols, ActivationFunction func) {
    int xdata i, j, index;  // Ƶ鿪ͷ

    for (i = 0; i < rows; i++) {
        for (j = 0; j < cols; j++) {
            index = i * cols + j;  // ѭʹı
            input[index] = func(input[index]);
        }
    }
}

void Conv2D_single_kernel(float* image, int img_height, int img_width,
                          float* kernel, int kernel_height, int kernel_width,
                          float* feature_map, int feature_map_height, int feature_map_width) {
    int xdata i, j, ki, kj;  // ѭƵ鿪ͷ
    int xdata img_i, img_j;  // ڼͼı
    float xdata sum;         // ڴ洢ı

    // ͼÿ
    for (i = 0; i < feature_map_height; i++) {
        for (j = 0; j < feature_map_width; j++) {
            sum = 0;  // ʼ
            // ˵ÿԪ
            for (ki = 0; ki < kernel_height; ki++) {
                for (kj = 0; kj < kernel_width; kj++) {
                    img_i = i + ki;  // ͼ
                    img_j = j + kj;  // ͼ
                    // Ƿͼ߽
                    if (img_i >= 0 && img_i < img_height && img_j >= 0 && img_j < img_width) {
                        sum += image[img_i * img_width + img_j] * kernel[ki * kernel_width + kj];
                    }
                }
            }
            // õֵ洢ͼĵǰλ
            feature_map[i * feature_map_width + j] = sum;
        }
    }
}
// ͼƫõĺ
void addBias(float *map, int map_rows, int map_cols, float *bias) {
    int xdata j, k;
    for (j = 0; j < map_rows; ++j) {
        for (k = 0; k < map_cols; ++k) {
            map[j * map_rows + k] += *bias;
        }
    }
}

// ػ
void max_pooling2d(float *input, int input_rows, int input_cols, int pool_size, int strides, float *output) {
    int xdata output_rows = (input_rows - pool_size) / strides + 1;
    int xdata output_cols = (input_cols - pool_size) / strides + 1;
    int xdata i, j, k, l, input_index;

    // ʼͼΪС
    for (i = 0; i < output_rows * output_cols; ++i) {
        output[i] = -FLT_MAX;
    }

    for (i = 0; i < output_rows; ++i) {
        for (j = 0; j < output_cols; ++j) {
            for (k = 0; k < pool_size; ++k) {
                for (l = 0; l < pool_size; ++l) {
                    input_index = (i * strides + k) * input_cols + (j * strides + l);
                    output[i * output_cols + j] = fmaxf(output[i * output_cols + j], input[input_index]);
                }
            }
        }
    }
}

// ͨľͼӣһָָڴ
void elementWiseAdd(float *result, float *in, int row, int col) {
    int xdata i;
    for (i = 0; i < row * col; i++) {
        result[i] += in[i];
    }
}

// άչƽ
void flatten(float *input, float *output, int rows, int cols, int ch) {
    int xdata k, j, i, x, y;
    for (k = 0; k < rows; k++) {
        for (j = 0; j < cols; j++) {
            for (i = 0; i < ch; i++) {
                x = i + j * ch + k * cols * ch;
                y = i * (rows * cols) + j + k * rows;
                output[x] = input[y];
            }
        }
    }
}

// ˷
void matrixMultiply_ABC(float a[], float b[], float c[], int rowsA, int colsA, int rowsB, int colsB) {
    int xdata i, j, k;
	  rowsB = 0;
    for (i = 0; i < rowsA; i++) {
        for (j = 0; j < colsB; j++) {
            c[i * colsB + j] = 0; // ʼCԪΪ0
            for (k = 0; k < colsA; k++) {
                c[i * colsB + j] += a[i * colsA + k] * b[k * colsB + j];
            }
        }
    }
}

// ӷ
void matrixAdd_ABC(float a[], float b[], int rows, int cols) {
    int xdata i, j;
    for (i = 0; i < rows; i++) {
        for (j = 0; j < cols; j++) {
            a[i * cols + j] = a[i * cols + j] + b[i * cols + j];
        }
    }
}
void Neural_Work(void)
{
    int xdata j, i;  // ѭƵͷ

    
    conv1_p = (float *)(rampool + 4096);  // [4][30][30]
    pool1_p = (float *)(rampool + 18496);  // [4][15][15]
    for (j = 0; j < 4; j++)
    {
       
        Conv2D_single_kernel((float*)mfcc1, 32, 32, (float*)(conv2d_weight0_kernel + j * 3 * 3), 3, 3, (float*)(conv1_p + j * 30 * 30), 30, 30); 
        addBias((float*)(conv1_p + j * 30 * 30), 30, 30, (float*)(conv2d_weight1_biases + j));
        apply_activation_function((float*)(conv1_p + j * 30 * 30), 30, 30, relu);
        max_pooling2d((float*)(conv1_p + j * 30 * 30), 30, 30, 2, 2, (float*)(pool1_p + j * 15 * 15));
    }
  
   
    compact_memory(rampool, (void**)&pool1_p, 3600); 
    conv2_temp_p = (float *)(rampool + 3600);  // [4][4][13][13]
    conv2_p = (float *)(rampool + 14416);  // [4][13][13]
    memset(conv2_p, 0, 4 * 13 * 13 * 4); 
    pool2_p = (float *)(rampool + 17120);  // [4][6][6]
    for (j = 0; j < 4; j++)
    {
        for (i = 0; i < 4; i++) 
        {
           
            Conv2D_single_kernel((float*)(pool1_p + i * 15 * 15), 15, 15, 
                                 (float*)(conv2d_weight2_kernel + (j * 4 + i) * 3 * 3), 
                                 3, 3, 
                                 (float*)(conv2_temp_p + j * 4 * 4 + i * 4), 
                                 13, 13
                                );
         
            elementWiseAdd((float*)(conv2_p + j * 13 * 13), (float*)(conv2_temp_p + j * 4 * 4 + i * 4), 13, 13);
        }
       
        addBias((float*)(conv2_p + j * 13 * 13), 13, 13, (float*)(conv2d_weight3_biases + j));
        apply_activation_function((float*)(conv2_p + j * 13 * 13), 13, 13, relu);
        max_pooling2d((float*)(conv2_p + j * 13 * 13), 13, 13, 2, 2, (float*)(pool2_p + j * 6 * 6));
    }
  
   
    conv3_temp_p = (float *)(rampool + 17696);  // [4][4][4][4]
    conv3_p = (float *)(rampool + 18720);  // [4][4][4][4]
    memset(conv3_p, 0, 4 * 4 * 4 * 4);
    for (j = 0; j < 4; j++)
    {
        for (i = 0; i < 4; i++) 
        {
             
            Conv2D_single_kernel((float*)(pool2_p + i * 6 * 6),
                                 6, 6, 
                                 (float*)(conv2d_weight4_kernel + (j * 4 + i) * 3 * 3), 
                                 3, 3, 
                                 (float*)(conv3_temp_p + j * 4 * 4 + i * 4), 
                                 4, 4
                                );
            
            elementWiseAdd((float*)(conv3_p + j * 4 * 4), (float*)(conv3_temp_p + j * 4 * 4 + i * 4), 4, 4);
        }
       
        addBias((float*)(conv3_p + j * 4 * 4), 4, 4, (float*)(conv2d_weight5_biases + j));
        apply_activation_function((float*)(conv3_p + j * 4 * 4), 4, 4, relu);
    }
  
    flattenD_p = (float *)(rampool + 18976);  // [64]
    flatten((float*)conv3_p, (float*)flattenD_p, 4, 4, 4);
    denseout1_p = (float *)(rampool + 19232);  // [8]
    matrixMultiply_ABC((float*)conv2d_weight6_kernel, (float*)flattenD_p, (float*)denseout1_p, 8, 64, 64, 1);
    matrixAdd_ABC((float*)denseout1_p, (float*)conv2d_weight7_biases, 8, 1);
    apply_activation_function((float*)denseout1_p, 8, 1, relu);
    denseout2_p = (float *)(rampool + 19296);  // [8]
    matrixMultiply_ABC((float*)conv2d_weight8_kernel, (float*)denseout1_p, (float*)denseout2_p, 3, 8, 8, 1);
    matrixAdd_ABC((float*)denseout2_p, (float*)conv2d_weight9_biases, 3, 1);   
    apply_activation_function((float*)denseout2_p, 3, 1, sigmoid);
//    print_frame(3, 1, (float*)denseout2_p, "%f");  
}

